#include "h.h"
#include "school.h"
#include "mouse.h"

/*
#define NO_MOUSE		1				/* Implementieren, wenn keine Maus sein soll*/
*/

#define XSTART			16
#define YSTART			4

#if !defined (MARKCOLOR)
#define MARKCOLOR		0x60
#endif

#define NAMEMAX		19
#define VORNMAX		16
#define STRASSMAX		38
#define PLORTMAX		25
#define TELMAX			19
#define GEBMAX			10
#define EMAILMAX		31
#define HANDYMAX		18
#define BEMMAX			55

#define ANZEIG			1
#define SUCHEN			2
#define HINZFG			3
#define ALPHABET		4
#define DRUCKEN		5
#define DATEI			6

#define NAME			1
#define VORNAME		2
#define GEB				3
#define TEL				4
#define STRASSE		5
#define PLZORT			6
#define EMAIL			7
#define HANDY			8
#define BEMERK			9

typedef struct adress_struktur
	{
	char name[NAMEMAX +1];
	char vorname[VORNMAX +1];
	char strasse[STRASSMAX +1];
	char plzort[PLORTMAX +1];
	char tel[TELMAX +1];
	char geburt[GEBMAX +1];
	char email[EMAILMAX +1];
	char handy[HANDYMAX +1];
	char bemerk[BEMMAX +1];
	} ADR;

FILE *fp;
ADR *adr = NULL;
int anz=0, change = 0;

char datei[13];

extern char mourow;
extern char mouse;
extern int  mouevent;

void memoryerror(void);
long lof(FILE *fp);
int openfile(void);
void savefile(void);
void markier(int n);
void mainscreen(int n);

int  endstr(char *cp);        /* gibt Position hinter dem letzten Buchst.zur*/
void setzeich(char *punkt, char zeichen);    /* Zeichen an punkt und Cursor */
void setzen(char *cp, char zeichen, int einfg);  /* Zeichen+Versetzen des Rests*/
void entfernen(char *cp);         /* Schmeit Zeichen an aktuellem cp raus. */
char* bearbeiten (char *copy, int zeile, int spalte, int *einfg, int *down);
					/*Bearbeiten von string bei (z/s); Rck:Adr des neuen Strings*/

void mark(int z, int s1, int s2);
void mark_n(ADR ** adrptr, int i0, int i, int n,int *pos);
									/* (de-)markiert bestimmte Adr-Teile */
void posinit (int *pos);      /* Feld pos mit Start- und End-x-Werten init. */
void put_i0(int i0);                    /* "i0" unten rechts ohne Farb-nd. */
void put_anz(int an);               /* "an" unten rechts ohne Farbattrib-nd*/
void statuszeile(int an);                                   /* anzeige-tips */
void setsatz (ADR *adress, int i, int loc, int *pos);
														/* einzelnen Satz an loc ausgeben */
void setscreen(ADR ** adrptr, int i0, int *pos, int i, int n, int anzeiganz);
												/*Dats ab i0 auf Bldschirm*/
int  strcomp(char *s1, char *s2);                   /* s1 == s2  ?  1  :  0 */
void writestr(char *dest, char *ch);            /* dest in Datei schreiben. */
void anzeige(ADR **adrptr, int anzeiganz, int marked);    /* Daten Anzeigen */
void anzeig(void);                                        /* Daten anzeigen */

int  such(char *string, char *comp);            /* Entspricht str dem Makro ?*/
int  sort(char *char1, char *char2, int lang);/*Welcher String ist im Alphabet*/
void init_string(char *string);               /* String leer initialisieren */
void suchen(void);					                            /* sucht Daten */

void init_neu (ADR *neu);		                 /* intialisiert ein ADR leer */
void hinzfg(void);                                  /* Datensatz hinzufgen */
void copystruct (char *dest, char *source);      /* kopiert Struktur ->Struk*/
void recurs(ADR *save, ADR **adrp, int *f, int i, int j);
															 /*rekursives Struktur-kopieren*/
void alphabet(void);					                  /* sortiert alphabetisch */

void drucken(void);               					            /* druckt Daten */
void execute(int n);


void main(int anzahl, char*string[])
	{
	int n=1, cont=1, k = pow(10,3);
	int nold=1;
	int i,j;
	if(anzahl < 2) strcpy(datei, "adressen.dat");
	else
		{
		strcpy(datei, string[1]);
		j = strlen(datei);
		for(i=0; i < j; i++)
			if(datei[i]=='.')
				{
				strcpy(&datei[i+1], "dat");
				i = j-1;
				break;
				}
		if(i == j) strcat(datei, ".dat");
		}

	mouinit(25,80);
#if defined NO_MOUSE
		mouse = (0==1);
#endif
	if(openfile() == TROUBLE) {ED; exit(1);}
	mainscreen(n);
	if(mouse)
		setmouarea(YSTART+3,0,YSTART+10,80);
	while(cont)
		{
		k=(kbhit()) ? keyb() : 255;
		if(k>='0' && k<'7')
			{
			n=k-48;
			if(!n) {cont=0; break;}
			markier(n);
			execute(n);
			continue;
			}
		switch(k)
			{
			case RETURN:
				if(!n) {cont=0; break;}
				execute(n);
				continue;

			case ESC:
				cont=0;
				continue;

			case UP:
				if(!n) n=7;
				markier(--n);
				if(mouse) movemouse((n) ? YSTART+2+n : YSTART+10, 40);
				continue;

			case DOWN:
				if(n>5) n=-1;
				markier(++n);
				if(mouse) movemouse((n) ? YSTART+2+n : YSTART+10, 40);
				continue;

			case ALT_X:
				cont=0;
				continue;
			}

		if(mouse)
			{
			if(( (n) ? n : 8) != mourow - YSTART - 2)
				{
				nold = n;
				n = mourow-YSTART-2;
				if(n==7)
					{
					n = (nold==0) ? 6: 0;
					movemouse((n) ? YSTART+2+n : YSTART+10, 40);
					}
				if(n==8) n=0;
				markier(n);
				}
			if(mouevent & LEFTP)
				{
				while(mouevent & LEFTP);
				if(!n) {cont=0; break;}
				execute(n);
            }
			}
		}
	if(change) savefile();
	fclose(fp);
	ED;
	exit(0);
	}

void quit(int errorlevel)
	{
	if(change) savefile();
	fclose(fp);
	ED;
	exit(errorlevel);
	}

void memoryerror(void)
	{
	ED;
	psyx("Beim Verndern der Datei im Speicher trat ein Fehler auf."
			"\n\rSie finden die Datei in dem Zustand, wie sie vor Ihrer "
			"letzten Vernderung war.");
	WAIT;
	ED;
	exit(1);
	}

long lof(FILE *fp)						/* ermittelt die Dateilnge */
	{
	long i;
	fseek(fp,0,SEEK_END);
	i=ftell(fp);
	rewind(fp);
	return(i);
	}

int openfile (void)					/* kopiert den Dateiinhalt in den Speicher*/
	{
	long longf;
	if((fp=fopen(datei,"r+"))==NULL)
		{
		ED;
		CUP(YSTART, XSTART);
		printf("Die Datei %s konnte nicht geffnet werden", datei);
		CUP(YSTART+1, XSTART);
		printf("bzw. existiert (noch) nicht.");
		CUP(YSTART+3, XSTART);
		printf("Adressen-Datei erstellen?");
		if(keyb()!='j') return TROUBLE;
		if((fp = fopen(datei,"w+"))==NULL) exit(1);
		}
	longf=lof(fp);
	anz = (int) (longf/sizeof(ADR));
	if((anz * sizeof(ADR)) < longf) anz++;
	if(anz && (adr=(ADR *) realloc(adr, longf)) == NULL) memoryerror();
	fread(adr, sizeof(ADR), anz, fp);
	rewind(fp);
	return ALL_RIGHT;
	}

void savefile(void)
	{
	if(fclose(fp)==EOF || (fp=fopen(datei,"w"))==NULL)
		{
		ED;
		psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
		exit(1);
		}
	fwrite(adr,sizeof(ADR),anz,fp);
	if(fclose(fp)==EOF)
		{
		ED;
		psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
		exit(1);
		}
	if((fp=fopen(datei,"r+"))==NULL)
		{
		ED;
		psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
		exit(1);
		}
	change = 0;
	}

void markier(int n)              /* markiert einen (Haupt-)Menpunkt */
	{
	static int nlast;
	int off=YSTART*160+XSTART*2;
	int seg=(peekb(0x40,0x49)==7)?0xb000:0xb800;
	off+=(nlast)?((nlast+2)*160):(10*160);
	for(;peekb(seg,off)!=32 || peekb(seg,off+2)!=32 || peekb(seg,off+4)!=32
					|| peekb(seg,off+6)!=32; off+=2)
		pokeb(seg,off+1,7);
	off=YSTART*160+XSTART*2;
	off+=(n)?((n+2)*160):(10*160);
	for(;peekb(seg,off)!=SPACE || peekb(seg,off+2)!=SPACE ||
				peekb(seg,off+4)!=SPACE || peekb(seg,off+6)!=SPACE; off+=2)
		pokeb(seg,off+1,MARKCOLOR);
	CUP((n)?(YSTART+n+2):(YSTART+10),XSTART+3);
	nlast=n;
	}

void mainscreen(int n)           /* Erzeugt das Hauptmen & markiert Menpkt*/
	{
	ED;
	ps(YSTART-1,XSTART,"Adressen-Verwaltung");
	ps(YSTART-1,XSTART+34,"V3.0");
	ps(YSTART+1, XSTART + 9, "Datei: \"");
	ps(YSTART+1, XSTART + 17, datei);
	ps(YSTART+1, XSTART + 17 + strlen(datei), "\"");
	ps(YSTART+3,XSTART,"1) Ausgeben (+ Bearbeiten/Lschen)");
	ps(YSTART+4,XSTART,"2) Suchen   (+ Bearbeiten/Lschen)");
	ps(YSTART+5,XSTART,"3) Hinzufgen");
	ps(YSTART+6,XSTART,"4) Alphabetisch sortieren und ausgeben");
	ps(YSTART+7,XSTART,"5) Adressen drucken");
	ps(YSTART+8,XSTART,"6) Datei wechseln");
	ps(YSTART+10,XSTART,"0) Beenden");
	ps(YSTART+12,XSTART+22,"(C) VOSSIM, 1997");
	markier(n);
	if(mouse) movemouse((n) ? YSTART+2+n : YSTART+9, 40);
	}

int endstr(char *cp)          /* gibt Position hinter dem letzten Buchst.zur*/
	{
	int lang=strlen(cp)-1;
	for(;*(cp+lang)==SPACE;lang--);
	return((lang < strlen(cp)-1) ? lang+1 : lang);
	}

void setzeich(char *punkt, char zeichen)  /* Zeichen an punkt und Cursor */
	{
	pyx(zeichen);
	*punkt = zeichen;
	}

void setzen(char *cp, char zeichen, int einfg)  /* Zeichen+Versetzen des Rests*/
	{
	int i;
	if(!einfg)
		{
		setzeich(cp, zeichen);
		return;
		}
	for(i=strlen(cp)-1;i>0;i--)
		*(cp+i) = *(cp+i-1);
	*cp = zeichen;
	psyx((char *)cp);
	}

void entfernen(char *cp)      /* Schmeit Zeichen an aktuellem cp raus. */
	{
	int i, lang=strlen(cp) -1;
	for(i=0;i<lang;i++)
		setzeich(cp +i, *(cp+i+1));
	setzeich(cp+lang,SPACE);
	}

char* bearbeiten (char *copy, int zeile, int spalte, int *einfg, int *down)
					/*Bearbeiten von string bei (z/s); Rck:Adr des neuen Strings*/
	{
	int k;
	int pos=0;
	int lang = strlen(copy) -1;
	if(copy==NULL) {*down=1; return(NULL);}
	CUP(zeile, spalte);
	while(1)
		{
		if((k=keyb())>31 && k<256)
			{
			setzen(copy+pos,k,*einfg);
			pos++;
			if(pos>lang) pos=lang;
			CUP(zeile, spalte + pos);
			}
		switch(k)
			{
			case ESC:
				*down=-3;
				return(NULL);

			case RETURN:
				*down=2;
				return(copy);

			case BACKSPACE:
				if(pos>0)
					{
					pos--;
					CUP(zeile, spalte + pos);
					entfernen(copy+pos);
					CUP(zeile, spalte + pos);
					}
				break;

			case EINFG:
				(*einfg)=!(*einfg);
				if(*einfg) cps(24, 2," EINFG ", MARKCOLOR);
				else cps(24,2," BER ", ((MARKCOLOR %16) * 16 + MARKCOLOR / 16));
				CUP(zeile, spalte+pos);
				break;

			case ENTF:
				entfernen(copy+pos);
				CUP(zeile, spalte+pos);
				break;

			case RIGHT:
				if(pos < lang) pos++;
				CUP(zeile, spalte+pos);
				break;

			case LEFT:
				if(pos>0) pos--;
				CUP(zeile, spalte+pos);
				break;

			case POS1:
				pos=0;
				CUP(zeile, spalte);
				break;

			case ENDE:
				pos=endstr(copy);
				CUP(zeile, spalte+pos);
				break;

			case UP:
				if(!(*down)) break;
				*down=-1;
				return(copy);

			case DOWN:
				if(!(*down)) break;
				*down=1;
				return(copy);

			case F10:
				if(*down==5) break;
				*down=3;
				return(copy);

			case ALT_X:
				quit(0);
			}
		}
	return(NULL);
	}

void mark(int z, int s1, int s2)     /* (de-)markiert Bereich einer Zeile */
	{
	int i=abs(s2)-s1;
	int color = (s2<0) ? 7 : MARKCOLOR;
	int seg=(peekb(0x40,0x49)==7) ? 0xb000 : 0xb800;
	int off=z*160+s1*2+1;
	while(i--)
		{
		pokeb(seg,off,color);
		off+=2;
		}
	}

void mark_n(ADR ** adrptr, int i0, int i, int n,int *pos)
									/* (de-)markiert bestimmte Adr-Teile */
	{
	static int i0last,nlast,zlast,s1last,s2last;

	mark(zlast,s1last,-s2last);
	if(i0last==i0)
		{
		if(nlast==GEB && adrptr[i0 + zlast/4]->geburt[0]==SPACE)
			ps(zlast, s1last + 1, " ");
		else if(nlast==TEL && adrptr[i0 + zlast/4]->tel[0]==SPACE)
			ps(zlast, s1last + 1, "     ");
		else if(nlast==EMAIL && adrptr[i0 + zlast/4]->email[0]==SPACE)
			ps(zlast, s1last + 1, "      ");
		else if(nlast==HANDY && adrptr[i0 + zlast/4]->handy[0]==SPACE)
			ps(zlast, s1last + 1, "      ");
		}
	zlast = i*4;
	if(n>4) zlast += (int)((n-3)/2);
	s1last = pos[(n-1)*2] -1;
	if(n==GEB)
		{
		s1last-=2;
		if(adrptr[i0+i]->geburt[0]==SPACE) ps(zlast, s1last + 1, "*");
		}
	else if(n==TEL)
		{
		s1last-=6;
		if(adrptr[i0+i]->tel[0]==SPACE) ps(zlast, s1last + 1, "Tel.:");
		}
	else if(n==EMAIL)
		{
		s1last-=7;
		if(adrptr[i0+i]->email[0]==SPACE) ps(zlast, s1last + 1, "eMail:");
		}
	else if(n==HANDY)
		{
		s1last-=7;
		if(adrptr[i0+i]->handy[0]==SPACE) ps(zlast, s1last + 1, "Handy:");
		}

	mark(zlast, s1last, s2last = pos[n *2 -1]);
	CUP(zlast, pos[(n-1) *2]);
	i0last = i0;
	nlast = n;
   }

void posinit (int *pos)     /* Feld pos mit Start- und End-x-Werten init. */
	{
	pos[0] = 5;
	pos[1] = NAMEMAX + 5;
	pos[2] = NAMEMAX + 6;
	pos[3] = NAMEMAX + VORNMAX + 6;
	pos[4] = NAMEMAX + VORNMAX + 9;
	pos[5] = NAMEMAX + VORNMAX + GEBMAX + 9;
	pos[6] = NAMEMAX + VORNMAX + GEBMAX + 16;
	pos[7] = NAMEMAX + VORNMAX + TELMAX + GEBMAX + 16;
	pos[8] = NAMEMAX -3;
	pos[9] = NAMEMAX + STRASSMAX - 3;
	pos[10] = NAMEMAX + STRASSMAX - 2 ;
	pos[11] = NAMEMAX + STRASSMAX + PLORTMAX -2;
	pos[12] = NAMEMAX + 4;
	pos[13] = NAMEMAX + EMAILMAX + 4;
	pos[14] = NAMEMAX + EMAILMAX + 12;
	pos[15] = NAMEMAX + EMAILMAX + HANDYMAX + 12;
	pos[16] = NAMEMAX - 3;
	pos[17] = NAMEMAX + BEMMAX - 3;
	}

void put_i0(int i0)               /* "i0" unten rechts ohne Farb-nd. */
	{
	i0++;
	CUP(24,70);
	pyx((i0/100) ? i0/100 + 48 : 32);
	pyx(((i0/10)%10) ? (i0/10) % 10 + 48 : 32);
	pyx(i0 % 10 + 48);
	}

void put_anz(int an)              /* "an" unten rechts ohne Farbattrib-nd*/
	{
	CUP(24,76);
	if(an/100)
		{
		pyx(an/100 + 48);
		pyx((an/10) % 10 + 48);
		pyx(an % 10 + 48);
		return;
		}
	if(an/10)
		{
		pyx((an/10) % 10 + 48);
		pyx(an % 10 + 48);
		return;
		}
	pyx(an % 10 + 48);
	}

void statuszeile(int an)                   /* anzeige-tips */
	{
	mark(24,0,80);
	ps(24,0,"  PFEILE   PgUP/PgDOWN   Pos1/Ende  ENTF  <: Auswahl   ESC: Abbruch  ");
	pcyx(24, 74,'/');
	put_anz((an>4) ? an-4 : 1);
	}

void setsatz (ADR *adress, int i, int loc, int *pos)  /* einzelnen Satz an loc ausgeben */
	{
	CUP(loc*4,0);
	put_intf(i+1,3);
	ps(loc*4, pos[0], (char *)&(adress -> name));
	ps(loc*4, pos[2], (char *)&(adress -> vorname));
	ps(loc*4, pos[4] - 2,(adress -> geburt[0]==SPACE)? " " : "*");
	ps(loc*4, pos[4], (char *)&(adress->geburt));
	ps(loc*4, pos[6] - 6,(adress -> tel[0]==SPACE)? "     " : "Tel.:");
	ps(loc*4, pos[6], (char*)&(adress->tel));
	ps(loc*4 +1, pos[8], (char *)&(adress->strasse));
	ps(loc*4 +1, pos[10], (char *)&(adress->plzort));
	ps(loc*4 +2, pos[12] - 7,(adress -> email[0]==SPACE)? "      " : "eMail:");
	ps(loc*4 +2, pos[12], (char *)&(adress->email));
	ps(loc*4 +2, pos[14] - 7,(adress -> handy[0]==SPACE)? "      " : "Handy:");
	ps(loc*4 +2, pos[14], (char*)&(adress->handy));


	ps(loc*4 +3, pos[16], (char*)&(adress->bemerk));
   }

void setscreen(ADR ** adrptr, int i0, int *pos, int i, int n, int anzeiganz)
												/*Dats ab i0 auf Bldschirm*/
	{
	int j,k;
	for(j=0;j<6;j++)
		{
		if(i0+j>=anzeiganz) break;
		setsatz(adrptr[i0+j],i0+j,j,pos);
		}
	put_i0(i0);
	if(j>5)
		{
		mark_n(adrptr, i0, i, n,pos);
		return;
		}
	CUP(j*4, 0);
	for(k=0; k<(6-j)*4*80; k++)
		pyx(SPACE);
	ps(j*4, 0, "      *** Keine weiteren Daten ***");
	mark_n(adrptr, i0, i, n, pos);
	}

int strcomp(char *s1, char *s2)      /* s1 == s2  ?  1  :  0 */
	{
	int i;
	for(i=0; i<=strlen(s1); i++)
		if(s1[i]!=s2[i]) return(0);
	return(1);
	}

void writestr(char *dest, char *ch)  /* dest in Datei schreiben. */
	{
	strcpy(dest, ch);
	fseek(fp, dest - (char *) adr, SEEK_SET);
	fwrite(dest, strlen(dest), 1, fp);
	rewind(fp);
/*	schreiben von dest an richtige Stelle innerhalb der Datei !!! *******/
	}

void erase(int satz)
	{
	int i, rest=(anz-(satz+1))*sizeof(ADR);
	char option[20];
	for(i=0;i<rest;i++)
		*(((char*) &adr[satz]) + i) = *(((char*) &adr[satz+1]) + i);
	anz--;
	if(!anz)
		{
		if(fclose(fp)==EOF)
			{
			ED;
			psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
			exit(1);
			}
      strcpy(option, "del ");
		strcat(option, datei);
		system(option);
		return;
		}
	if((adr=(ADR *)realloc(adr,anz*sizeof(ADR)))==NULL) memoryerror();
	savefile(); 	/* Neuschreiben der Datei */
	}

void anzeige(ADR **adrptr, int anzeiganz, int marked)    /* Daten Anzeigen */
	{
	int k, stop;
	char *ch = NULL;
	char *bearbeitptr;
	int *f=NULL;
	int save;
	int bearbeitzeile;
	int i=0, i0 = 0;
	int j;
	int einfg=1;
	int pos[18];
	int down=1;
	char copy[9];
	char neu_datei[13];
	FILE* datei_neu;

	if(anzeiganz==0)
		{
		ps(YSTART,XSTART, "***** Keine Daten vorhanden *****");
		WAIT;
		return;
		}
	posinit(pos);
	statuszeile(anzeiganz);
	setscreen(adrptr, i0, pos, i, marked, anzeiganz);
	while(1)
		{
		if((k=keyb())>64 && k<123)
			{
			if(k>96) k-=32;
			if(k<91)
				{
				for(j=0;j<anzeiganz;j++)
					if((adrptr[j]->name[0]>=k && adrptr[j]->name[0]<91)
							|| adrptr[j]->name[0] >= k+32)
						{
						i0=j;
						i=0;
						marked=1;
						if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
						setscreen(adrptr, i0,pos,i,marked, anzeiganz);
						break;
						}
				if(j==anzeiganz)
					{
					i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
					i=0;
					marked=1;
					setscreen(adrptr, i0,pos,i,marked, anzeiganz);
					}
				}
			continue;
			}
		switch(k)
			{
			case ESC:
				free(ch);
				free(f);
				return;

			case RETURN:
				if(i0 + i >= anz) ;
				else
					{
					ED;
					setsatz(adrptr[i0+i],i0+i,i,pos);
					mark_n(adrptr, i0, i, marked, pos);
					switch(marked)
						{
						case NAME:
							bearbeitptr = (char*)&(adrptr[i0 + i] -> name);
							break;
						case VORNAME:
							bearbeitptr = (char*)&(adrptr[i0 + i] -> vorname);
							break;
						case TEL:
							bearbeitptr = (char*)&(adrptr[i0 + i]->tel);
							break;
						case GEB:
							bearbeitptr = (char*)&(adrptr[i0 + i]->geburt);
							break;
						case STRASSE:
							bearbeitptr = (char*)&(adrptr[i0 + i]->strasse);
							break;
						case PLZORT:
							bearbeitptr = (char*)&(adrptr[i0 + i]->plzort);
							break;
						case EMAIL:
							bearbeitptr = (char*)&(adrptr[i0 + i]->email);
							break;
						case HANDY:
							bearbeitptr = (char*)&(adrptr[i0 + i]->handy);
							break;

						case BEMERK:
							bearbeitptr = (char*)&(adrptr[i0 + i]->bemerk);
							break;
						default:
							bearbeitptr = NULL;
						}
					if((ch=(char *)realloc(ch, strlen(bearbeitptr)+1)) == NULL) memoryerror();
					strcpy(ch,bearbeitptr);

					bearbeitzeile = (marked <= 4) ? i*4 : i*4 +1;
					if(marked>6) bearbeitzeile+=(marked <= HANDY)?1:2;

					mark(24,0,80);
					ps(24,0,"   EINFG    Pfeile   Pos1/Ende   Entf   Backspace   <: OK  ESC: Abbruch");

					j=1;
					einfg=1;
					ch = bearbeiten(ch, bearbeitzeile, pos[(marked-1)*2],&einfg,&j);
					if(ch != NULL && !strcomp(bearbeitptr,ch)) writestr(bearbeitptr, ch);
					ps(bearbeitzeile, pos[(marked-1)*2], (char *)bearbeitptr);

					setscreen(adrptr, i0,pos,i,marked, anzeiganz);
					statuszeile(anzeiganz);
					CUP(bearbeitzeile, pos[(marked-1) * 2]);
					}
				break;

			case POS1:
				mark_n(adrptr, i0, i, marked=1, pos);
				break;

			case ENDE:
				if(marked<5) marked = 4;
				else if(marked<7) marked = 6;
				else if(marked<9) marked = 8;
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case RIGHT:
				marked++;
				if(marked>BEMERK)
					{
					marked=1;
					i++;
					if(i>5)
						{
						i=5;
						i0++;
						if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anz-5 : 0;
						else setscreen(adrptr, i0,pos,i,marked, anzeiganz);
						}
					if(i+i0>=anzeiganz) i--;
					}
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case LEFT:
				marked--;
				if(marked<1)
					{
					marked=BEMERK;
					i--;
					if(i<0)
						{
						i=0;
						i0--;
						if(i0<0) i0=0;
						else setscreen(adrptr, i0,pos,i,marked, anzeiganz);
						}
					}
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case UP:
				if(marked<5)
					{
					if(marked>1) marked = BEMERK;
					i--;
					if(i<0)
						{
						i=0;
						marked=1;
						i0--;
						if(i0<0) i0=0;
						else setscreen(adrptr, i0,pos,i,marked, anzeiganz);
						}
					}
				else
					marked=(marked==5) ? 1 : marked-2;
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case DOWN:
				if(marked==NAME || marked == BEMERK)
					{
					if(marked==BEMERK) marked = 2;
					i++;
					if(i>5)
						{
						i=5;
						marked = NAME;
						i0++;
						if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
						else setscreen(adrptr, i0,pos,i,marked, anzeiganz);
						}
					if(i+i0>=anzeiganz) i--;
					}
				else {
						if(marked<3) marked = 3;
						marked+=2;
						if(marked>BEMERK) marked = BEMERK;
						}
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case PgUP:
				if(i0<1) break;
				i0=(i0<7) ? 0 : i0-6;
				i = 0;
				marked = 1;
				setscreen(adrptr, i0, pos,i,marked, anzeiganz);
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case PgDOWN:
				if(i0>=anzeiganz-5) break;
				i0=(i0>=anzeiganz-11) ? anzeiganz-5 : i0+6;
				if(i+i0>=anzeiganz) i--;
				i = 0;
				marked = 1;
				setscreen(adrptr, i0, pos,i,marked, anzeiganz);
				mark_n(adrptr, i0, i, marked, pos);
				break;

			case ENTF:
				stop = TROUBLE;
				if(i0 + i >= anzeiganz) break;
				ED;
				setsatz(adrptr[i0+i],i0+i,i,pos);
				cps(i*4 + 4, 5,
				"  Diesen Datensatz lschen(l), verschieben(v), oder kopieren(k)?  ",
							MARKCOLOR);
				do{
					switch(k = keyb())
						{
						case 'v':
						case 'V':
							k = 'v';
						case 'k':
						case 'K':
							if(k == 'K') k = 'k';
							stop = ALL_RIGHT;
							strcpy(copy, "        ");

							ps(i*4 + 4, 7,
								"                  In welche Datei:                               ");
							CUP(i*4 + 4, 42);
							bearbeiten(copy, i*4 + 4, 42, &einfg, &down);
							if(down != 2) break;

							for(j = strlen(copy)-1; copy[j] == SPACE; copy[j]=0, j--);
							if(strlen(copy) == 0) strcpy(copy, "adressen");
							strcpy(neu_datei, copy);
							strcat(neu_datei, ".dat");

							if((datei_neu = fopen(neu_datei,"r+"))==NULL)
								{
								ED;
								CUP(YSTART, XSTART);
								printf("Die Datei %s konnte nicht geffnet werden", neu_datei);
								CUP(YSTART+1, XSTART);
								printf("bzw. existiert (noch) nicht.");
								CUP(YSTART+3, XSTART);
								printf("Adressen-Datei erstellen?");
								if(keyb()!='j') break;
								if((datei_neu = fopen(neu_datei,"w+"))==NULL) exit(1);
								}

							fseek(datei_neu, 0, SEEK_END);
							fwrite(adrptr[i0 + i], sizeof(ADR), 1, datei_neu);
							if(fclose(datei_neu) == EOF)
								{
								ED;
								psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
								exit(1);
								}

							if(k == 'k')
								break;
						case 'l':
						case 'L':
							if((f=(int *)realloc(f,anzeiganz*sizeof(int)))==NULL) memoryerror();
							for(j=0;j<anzeiganz; j++)
								f[j]=((char*)adrptr[j] - (char *)adr)/sizeof(ADR);
							save=f[i0+i];
							erase(((char*)adrptr[i0+i] - (char *)adr)/sizeof(ADR));
							anzeiganz--;
							for(j = 0;j<i0+i;j++)
								adrptr[j] = (f[j]<save) ? &adr[f[j]] : &adr[f[j]-1];
							for(j=i0+i;j<anzeiganz;j++)
								adrptr[j]=(f[j+1]<save) ? &adr[f[j+1]] : &adr[f[j+1]-1];
							stop = ALL_RIGHT;
							break;

						case ESC:
							stop = ALL_RIGHT;
							break;
						case ALT_X:
							quit(0);
						}
					}
				while (stop != ALL_RIGHT);
				ED;
				if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
				setscreen(adrptr, i0,pos,i,marked, anzeiganz);
				statuszeile(anzeiganz);
				bearbeitzeile = (marked <= 4) ? i*4 : i*4 +1;
				if(marked==7) bearbeitzeile++;
				CUP(bearbeitzeile, pos[(marked-1)*2]);
				break;

			case ALT_X:
				quit(0);
            }
		}
	}

void anzeig(void)                        /* Menpunkt Anzeigen */
	{
	int i;
	ADR **adrptr;
	if(anz && (adrptr=(ADR **)malloc(anz * sizeof(char *)))==NULL) memoryerror();
	for(i=0;i<anz;i++)
		adrptr[i] = &adr[i];
	anzeige(adrptr, anz, 1);
	if(anz) free(adrptr);
	}

int such(char *string, char *comp)             /* Entspricht str dem Makro ?*/
	{
	int i, j, k, lang=strlen(comp), lang2;
	int comp1, comp2;
	if(comp[0]!='*')
		{
		for(i=0; i<lang; i++)
			{
			comp1=string[i];
			comp2=comp[i];
			if(comp1>64 && comp1<91) comp1+=32;
			if(comp2>64 && comp2<91) comp2+=32;
			if(comp2 != '?' && comp1 != comp2) return(0);
			}
		return(1);
		}
	lang2 = strlen(string) - lang + 2;
	for(i=0;i<lang2;i++)
		{
		k=1;
		for(j=0; j<lang-1; j++)
			{
			comp1=string[i+j];
			comp2=comp[j+1];
			if(comp1>64 && comp1<91) comp1+=32;
			if(comp2>64 && comp2<91) comp2+=32;
			if(comp2 != '?' && comp1 != comp2) k=0;
			}
		if(k) return(1);
		}
	return(0);
	}

int sort(char *char1, char *char2, int lang) /*Welcher String ist im Alphabet*/
	{
	int k, comp1, comp2;
	for(k=0; k<lang; k++)
		{
		comp1 = char1[k];
		comp2 = char2[k];
		if(comp1>96 && comp1<123) comp1-=32;
		if(comp1==132 || comp1==142) comp1=65;
		if(comp1==148 || comp1==153) comp1=79;
		if(comp1==129 || comp1==154) comp1=85;
		if(comp2>96 && comp2<123) comp2-=32;
		if(comp2==132 || comp2==142) comp2=65;
		if(comp2==148 || comp2==153) comp2=79;
		if(comp2==129 || comp2==154) comp2=85;

		if(comp1 > comp2) return(1);
		if(comp1 < comp2) return(-1);
		}
	return(0);
   }

void init_string(char *string)            /* String leer initialisieren */
	{
	int i, lang=strlen(string);
	for(i=0; i<lang; i++)
		{
		string[i]=SPACE;
		pyx(SPACE);
		}
	}

void suchen(void)                             /* sucht Daten */
	{
	int ystart = YSTART + 2;
	int zeile = ystart + 2, spalte = XSTART + 9;
	int einfg=1, down=1;
	int i,j,l;
	int suchanz=0;
	int off, check, check2, sortiert;
	int marked;
	char irgendwas[BEMMAX+2];
	char *bearbeitptr;
	ADR *save;
	ADR **adrptr;
	ADR neu;
	if (!anz)
		{
		ps(YSTART, XSTART, "Was wollen sie suchen? -- Keine Daten vorhanden!");
		WAIT;
		return;
		}
	if((adrptr=(ADR**)malloc(anz * sizeof(char *)))==NULL) memoryerror();
	for(i=0;i<anz;i++)
		adrptr[i] = &adr[i];
	init_neu(&neu);
	for(i=0;i<BEMMAX;i++)
		irgendwas[i]=SPACE;
	irgendwas[BEMMAX]=0;
	bearbeitptr = (char *)&neu.name;
	ps(ystart,XSTART,"Suchmakro eingeben");       /* Suchmakro festlegen */
	ps(ystart+2,XSTART-5,"Name:");
	ps(ystart+3,XSTART-5,"Vorname:");
	ps(ystart+4,XSTART-5,"Strae:");
	ps(ystart+5,XSTART-5,"PLZ Ort:");
	ps(ystart+6,XSTART-5,"Telefon-Nr.:");
	ps(ystart+7,XSTART-5,"Geburtstag:");
	ps(ystart+8,XSTART-5,"eMail-Adr.:");
	ps(ystart+9,XSTART-5,"Handy/Pager:");
	ps(ystart+10,XSTART-5,"Bemerkungen:");
	ps(ystart+11,XSTART-5,"Irgendwo:");
	mark(ystart + 2, spalte-1, spalte + NAMEMAX);
	mark(24,0,80);
	ps(24,0,"   EINFG   Pfeile/Pos1/Ende/Entf/Backspace  <: Suche starten  ESC: Abbruch");
	CUP(zeile,spalte);
	while (down!=-3)
		{
		init_string(bearbeitptr);
		switch(zeile - ystart - 1)
			{
			case NAME:
				marked=NAME;
				bearbeitptr = (char *)&neu.name;
				break;
			case VORNAME:
				marked=VORNAME;
				bearbeitptr = (char *)&neu.vorname;
				break;
			case 3:
				marked=STRASSE;
				bearbeitptr = (char *)&neu.strasse;
				break;
			case 4:
				marked=PLZORT;
				bearbeitptr = (char *)&neu.plzort;
				break;
			case 5:
				marked=TEL;
				bearbeitptr = (char *)&neu.tel;
				break;
			case 6:
				marked=GEB;
				bearbeitptr = (char *)&neu.geburt;
				break;
			case EMAIL:
				marked=EMAIL;
				bearbeitptr = (char *)&neu.email;
				break;
			case HANDY:
				marked=HANDY;
				bearbeitptr = (char *)&neu.handy;
				break;
			case BEMERK:
				marked=BEMERK;
				bearbeitptr = (char *)&neu.bemerk;
				break;
			case BEMERK+1:
				marked=1;
				bearbeitptr = irgendwas;
				break;
			default:
				bearbeitptr = NULL;
			}
		mark(zeile, spalte-1, spalte+strlen(bearbeitptr));
		CUP(zeile,spalte);
		down=5;
		bearbeiten(bearbeitptr, zeile, spalte, &einfg, &down);
		mark(zeile, spalte-1, -(spalte + strlen(bearbeitptr)));
		CUP(zeile,spalte);
		zeile+= (down>0) ? 1 : -1;
		if(zeile > ystart + BEMERK + 2) zeile = ystart + NAME + 1;
		if(zeile < ystart + NAME + 1) zeile = ystart + BEMERK + 2;
		if(down==2 && bearbeitptr[0]!=SPACE) break;
		}
	if(down==-3) {free(adrptr);return;}
	ED;                                               /* Suchen */
	ps(YSTART, XSTART,"Die Suche luft...");
	for(i=strlen(bearbeitptr)-1;i>0;i--)
		if(bearbeitptr[i]!=SPACE) break;
	bearbeitptr[i+1] = 0;
	if(bearbeitptr!=irgendwas)
		{
		off = bearbeitptr - (char *)&neu;
		for(i=0;i<(anz>1) * (anz-2) +1;i++)
			{
			if((check = such((char *)adrptr[i] + off, bearbeitptr))!=0 && !i)
				suchanz++;
			if(!check && i) break;
			for(j=i+1;j<anz;j++)
				{
				check2 = such((char *)adrptr[j] + off, bearbeitptr);
				if(!check2 && i) break;
				if(!i && check2) suchanz++;
				if(check2)
					if(check)
						if((sortiert =
						sort((char *)adrptr[i] + off, (char *)adrptr[j] + off, strlen(&adr[i])))
							==1 ||
							(!sortiert && sort((char *)adrptr[i], (char *)adrptr[j], sizeof(ADR)) == 1))
							{
							save = adrptr[j];
							for(l=j; l>i; l--)
								adrptr[l] = adrptr[l-1];
							adrptr[i] = save;
							}
						else
							{
							save = adrptr[j];
							for(l=j; l>i+1; l--)
								adrptr[l] = adrptr[l-1];
							adrptr[i+1] = save;
							}
					else
						{
						save=adrptr[j];
						adrptr[j] = adrptr[i];
						adrptr[i] = save;
						check=1;
						}
				}
			}
		}
	else
		{
		for(i=strlen(irgendwas)+1; i>0; i--)
			irgendwas[i] = irgendwas[i-1];
		irgendwas[0]='*';
		for(i=0;i<anz-1;i++)
			{
			check = such((char *)&(adrptr[i]->name), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->vorname), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->strasse), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->plzort), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->tel), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->geburt), bearbeitptr);
			if(!check) check = such((char *)&(adrptr[i]->bemerk), bearbeitptr);
			if(!check && i) break;
			if(!i && check) suchanz++;
			for(j=i+1;j<anz;j++)
				{
				check2 = such((char *)&(adrptr[j]->name), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->vorname), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->strasse), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->plzort), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->tel), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->geburt), bearbeitptr);
				if(!check2) check2 = such((char *)&(adrptr[j]->bemerk), bearbeitptr);
				if(!check2 && i) break;
				if(!i && check2) suchanz++;
				if(check2)
					if(check)
						if(sort((char*)adrptr[i], (char*)adrptr[j], sizeof(ADR)) == 1)
							{
							save = adrptr[j];
							for(l=j; l>i; l--)
								adrptr[l] = adrptr[l-1];
							adrptr[i] = save;
							}
						else
							{
							save = adrptr[j];
							for(l=j; l>i+1; l--)
								adrptr[l] = adrptr[l-1];
							adrptr[i+1] = save;
                     }
					else
						{
						save=adrptr[j];
						adrptr[j] = adrptr[i];
						adrptr[i] = save;
						check=1;
						}
				}
			}
		}
	ps(YSTART, XSTART,"                  ");
	anzeige(adrptr, suchanz, marked);      /* Anzeigen der gefundenen Daten */
	free(adrptr);
	}

void init_neu (ADR *neu)                 /* intialisiert ein ADR leer */
	{
	int i;
	for(i=0;i<NAMEMAX;i++)
		neu->name[i] = SPACE;
	neu -> name[i] = 0;

	for(i=0;i<VORNMAX;i++)
		neu->vorname[i] = SPACE;
	neu -> vorname[i] = 0;

	for(i=0;i<STRASSMAX;i++)
		neu->strasse[i] = SPACE;
	neu -> strasse[i] = 0;

	for(i=0;i<PLORTMAX;i++)
		neu->plzort[i] = SPACE;
	neu -> plzort[i] = 0;

	for(i=0;i<TELMAX;i++)
		neu->tel[i] = SPACE;
	neu -> tel[i] = 0;

	for(i=0;i<GEBMAX;i++)
		neu->geburt[i] = SPACE;
	neu -> geburt[i] = 0;

	for(i=0;i<EMAILMAX;i++)
		neu->email[i] = SPACE;
	neu -> email[i] = 0;

	for(i=0;i<HANDYMAX;i++)
		neu->handy[i] = SPACE;
	neu -> handy[i] = 0;

	for(i=0;i<BEMMAX;i++)
		neu->bemerk[i] = SPACE;
	neu -> bemerk[i] = 0;
	}

void hinzfg(void)
	{
	int ystart = YSTART + 2;
	int zeile = ystart + 2, spalte = XSTART + 9;
	int einfg=1, down=1;
	int i;
	char *bearbeitptr;
	ADR neu;
	init_neu(&neu);
	ps(ystart,XSTART,"Datensatz Nr. ");
	printf("%d",anz+1);
	ps(ystart+2,XSTART-5,"Name:");
	ps(ystart+3,XSTART-5,"Vorname:");
	ps(ystart+4,XSTART-5,"Strae:");
	ps(ystart+5,XSTART-5,"PLZ Ort:");
	ps(ystart+6,XSTART-5,"Telefon-Nr.:");
	ps(ystart+7,XSTART-5,"Geburtstag:");
	ps(ystart+8,XSTART-5,"eMail-Adr.:");
	ps(ystart+9,XSTART-5,"Handy/Pager:");
	ps(ystart+10,XSTART-5,"Bemerkungen:");
	mark(ystart + 2, spalte-1, spalte + NAMEMAX);
	mark(24,0,80);
	ps(24,0,"   EINFG   Pfeile/Pos1/Ende/Entf/Backspace  <: OK  ESC: Abbruch F10: bernahme");
	while (abs(down)<3)
		{
		switch(zeile - ystart - 1)
			{
			case NAME:
				bearbeitptr = (char*)&neu.name;
				break;
			case VORNAME:
				bearbeitptr = (char*)&neu.vorname;
				break;
			case 3:
				bearbeitptr = (char*)&neu.strasse;
				break;
			case 4:
				bearbeitptr = (char*)&neu.plzort;
				break;
			case 5:
				bearbeitptr = (char*)&neu.tel;
				break;
			case 6:
				bearbeitptr = (char*)&neu.geburt;
				break;
			case EMAIL:
				bearbeitptr = (char*)&neu.email;
				break;
			case HANDY:
				bearbeitptr = (char*)&neu.handy;
				break;

			case BEMERK:
				bearbeitptr = (char*)&neu.bemerk;
				break;
			default:
				bearbeitptr = NULL;
			}
		mark(zeile, spalte-1, spalte+strlen(bearbeitptr));
		CUP(zeile,spalte);
		bearbeiten(bearbeitptr, zeile, spalte, &einfg, &down);
		mark(zeile, spalte-1, -(spalte + strlen(bearbeitptr)));
		zeile+= (down>0) ? 1 : -1;
		if(zeile == ystart + BEMERK + 2 && down==2) break;
		if(zeile > ystart + BEMERK + 1) zeile = ystart + NAME + 1;
		if(zeile < ystart + NAME + 1) zeile = ystart + BEMERK + 1;
		}
	if(neu.name[0] == SPACE || down == -3) return;
	anz++;
	if((adr=(ADR*)realloc(adr, anz * sizeof(ADR))) == NULL) memoryerror();
	for(i=0;i<sizeof(ADR);i++)
		*(((char*) &adr[anz-1]) + i) = *(((char*) &neu) + i);
	change = 1;
	ED;
	hinzfg();
	}

void copystruct (char *dest, char *source)      /* kopiert Struktur ->Struk*/
	{
	int i, limit=sizeof(ADR);
	for (i=0;i<limit;i++)
		dest[i] = source[i];
	}

void recurs(ADR *save, ADR **adrp, int *f, int i, int j)
												/*rekursives Struktur-kopieren*/
	{
	f[j]=0;
	if(adrp[j]==&adr[i])
		{
		copystruct((char*)&adr[j], (char*)save);
		return;
		}
	copystruct((char*)&adr[j],(char*)adrp[j]);
	recurs(save, adrp, f, i, ((char*)adrp[j] - (char *)adr)/sizeof(ADR));
	}

void alphabet(void)                  /* sortiert alphabetisch */
	{
	ADR **adrptr;
	int i,j,k,l;
	ADR savestruct;
	int *f;
	char comp1, comp2;
	ADR *save;
	if(!anz)
		{
		ps(YSTART, XSTART, "Es gibt nichts zu sortieren!");
		WAIT;
		return;
		}
	if((adrptr=(ADR**)malloc(anz * sizeof(char *)))==NULL) memoryerror();
	if((f=(int*)malloc(anz * sizeof(int)))==NULL) memoryerror();
	for(i=0;i<anz;i++)
		adrptr[i] = &adr[i];
	ps(YSTART+1, XSTART, "Sortiere...");
	for(i=0;i<anz-1;i++)
		for(j=i+1;j<anz;j++)
			for(k=0; k<sizeof(ADR); k++)
				{
				comp1 = *((char *)adrptr[i] + k);
				comp2 = *((char *)adrptr[j] + k);
				if(comp1>96 && comp1<123) comp1-=32;
				if(comp1==132 || comp1==142) comp1=65;
				if(comp1==148 || comp1==153) comp1=79;
				if(comp1==129 || comp1==154) comp1=85;
				if(comp2>96 && comp2<123) comp2-=32;
				if(comp2==132 || comp2==142) comp2=65;
				if(comp2==148 || comp2==153) comp2=79;
				if(comp2==129 || comp2==154) comp2=85;

				if(comp1>comp2)
					{
					save = adrptr[j];
					for(l=j; l>i; l--)
						adrptr[l] = adrptr[l-1];
					adrptr[i] = save;
					change = 1;
					}
				if(comp1!=comp2) k=sizeof(ADR);
				}
	if(!change)
		{
		ps(YSTART+1, XSTART, "           ");
		anzeige(adrptr, anz, 1);
		free(adrptr);
		free(f);
		return;
		}
	for(i=0; i<anz; i++)
		if(adrptr[i] != &adr[i]) f[i] = 1;
		else f[i]=0;
	for(i=0; i<anz; i++)
		if(f[i])
			{
			copystruct((char*)&savestruct, (char*)&adr[i]);
			recurs(&savestruct, adrptr, f, i, i);
			}
	savefile();
	ps(YSTART+1, XSTART, "           ");
	anzeig();
	free(adrptr);
	free(f);
	}

void statusprn(int an)                   /* anzeige-tips */
	{
	mark(24,0,80);
	ps(24,0,"  Pfeile  <:(De-/)Markieren  ^Y:Clear  ^I:Invert F10:Weiter  ESC:Abbr");
	pcyx(24, 74,'/');
	put_anz((an>4) ? an-4 : 1);
	}

void markdiff(int i, int color)
	{
	mark(i*4,0,(color) ? 320 : -320);
	}

void markprn_n(int i, int i0, int *druck)
	{
	static int ilast;
	int color= MARKCOLOR/16 + (MARKCOLOR % 16) *16;
	int color2=(druck[i0+ilast]) ? MARKCOLOR : 0x7;
	int j;
	int off1=i*4*160+8;
	int off2=ilast*4*160+8;
	int seg=(peekb(0x40,0x49)==7)?0xb000:0xb800;
	for(j=0;j<=NAMEMAX;j++)
		{
		pokeb(seg,off2+j*2+1,color2);
		pokeb(seg,off1+j*2+1,color);
		}
	CUP(i*4,5);
	ilast=i;
	}

void setscreenprn(ADR **adrptr, int i0, int *pos, int i,
										int anzeiganz, int *druck)
	{
	static int i0last;
	int j;
	setscreen(adrptr, i0, pos,i,1, anzeiganz);
	for(j=0;j<6;j++)
		if(druck[i0+j]!=druck[i0last+j]) markdiff(j, druck[i0+j]);
	markprn_n(i, i0, druck);
	i0last=i0;
	}

int anzeigprn(int* druck)                        /* Druckstze auswhlen */
	{
	int k;
	int i=0, i0 = 0;
	int j;
	int cont=1;
	int pos[18];
	int anzeiganz=anz;
	ADR **adrptr;

	ED;

	if((adrptr=(ADR **)malloc(anz * sizeof(char *)))==NULL) memoryerror();
	for(j=0;j<anzeiganz;j++)
		adrptr[j] = &adr[j];
	posinit(pos);
	statusprn(anzeiganz);
	setscreenprn(adrptr, i0, pos,i, anzeiganz, druck);
	while(cont)
		{
		switch(k=keyb())
			{
			case ESC:
				free(adrptr);
				return(1);
			case RETURN:
				druck[i0+i]=!druck[i0+i];
				markdiff(i, druck[i0+i]);
				markprn_n(i,i0,druck);
				break;

			case STRG_Y:
				for(j=0; j<anzeiganz; j++)
					druck[j]=0;
				for(j=0; j<6; j++)
					mark(j*4,0,-320);
				markprn_n(i, i0, druck);
				break;

			case STRG_I:
				for(j=0; j<anzeiganz; j++)
					druck[j]=!druck[j];
				for(j=0; j<6; j++)
					mark(j*4,0, (druck[i0 + j]) ? 320 : -320);
				markprn_n(i, i0, druck);
				break;

			case UP:
				i--;
				if(i<0)
					{
					i=0;
					i0--;
					if(i0<0) i0=0;
					else setscreenprn(adrptr, i0,pos,i, anzeiganz, druck);
					}
				mark_n(adrptr, i0, i, 1, pos);
				markprn_n(i, i0, druck);
				break;
			case DOWN:
				i++;
				if(i>5)
					{
					i=5;
					i0++;
					if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
					else setscreenprn(adrptr, i0,pos,i, anzeiganz, druck);
					}
				if(i+i0>=anzeiganz) i--;
				mark_n(adrptr, i0, i, 1, pos);
				markprn_n(i, i0, druck);
				break;
			case PgUP:
				if(i0<1) break;
				i0=(i0<7) ? 0 : i0-6;
				i = 0;
				setscreenprn(adrptr, i0, pos,i, anzeiganz, druck);
				markprn_n(i, i0, druck);
				break;
			case PgDOWN:
				if(i0>=anzeiganz-5) break;
				i0=(i0>=anzeiganz-11) ? anzeiganz-5 : i0+6;
				if(i+i0>=anzeiganz) i--;
				i = 0;
				setscreenprn(adrptr, i0, pos,i, anzeiganz, druck);
				markprn_n(i, i0, druck);
				break;
			case F10:
				free(adrptr);
				return(0);
			case ALT_X:
				quit(0);
			default:
				if(k>64 && k<123)
					{
					if(k>96) k-=32;
					if(k<91)
						{
						for(j=0;j<anzeiganz;j++)
							if((adrptr[j]->name[0]>=k && adrptr[j]->name[0]<91)
									|| adrptr[j]->name[0] >= k+32)
								{
								i0=j;
								i=0;
								if(i0>=anzeiganz-4) i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
								setscreenprn(adrptr, i0,pos,i, anzeiganz, druck);
								break;
								}
						if(j==anzeiganz)
							{
							i0 = (anzeiganz>5) ? anzeiganz-5 : 0;
							i=0;
							setscreenprn(adrptr, i0,pos,i, anzeiganz,druck);
							}
						}
					}
			}
		}
	free(adrptr);
	return(0);
	}

void drucksatz(ADR *dsatz, int *f)
	{
	int i;
	FILE *out;
	out=stdprn;
	fprintf(out, "   ");
	if(f[0])
		{
		fprintf(out, (char*)dsatz->name);
		fprintf(out, " ");
		}
	if(f[1])
		{
		fprintf(out, (char*)dsatz->vorname);
		fprintf(out, " ");
		}
	if(f[5])
		if(dsatz->geburt[0] != SPACE)
			{
			fprintf(out, "* ");
			fprintf(out, (char*)dsatz->geburt);
			fprintf(out, " ");
			}
		else {
			fprintf(out, "  ");
			fprintf(out, (char*)dsatz->geburt);
			fprintf(out, " ");
			}
	if(f[4])
		if(dsatz->tel[0] != SPACE)
			{
			fprintf(out, "Tel.: ");
			fprintf(out, (char*)dsatz->tel);
			}
	fprintf(out,"\n");
	if(!f[2] && !f[3] && !f[6] && !f[7] && !f[8]) return;
	for(i=0;i<=NAMEMAX-6;i++)
		fprintf(out, " ");
	if(f[2])
		{
		fprintf(out, (char*)dsatz->strasse);
		fprintf(out, " ");
		}
	if(f[3])
		fprintf(out, (char*)dsatz->plzort);
	if(f[2] || f[3])
		{
		fprintf(out,"\n");
		if(!f[6] && !f[7] && !f[8]) return;
		for(i=0;i<=NAMEMAX-6;i++)
			fprintf(out, " ");
		}

	if(f[6])
		if(dsatz->email[0] != SPACE)
			{
			fprintf(out, "eMail: ");
			fprintf(out, (char*)dsatz->email);
			fprintf(out, " ");
			}
		else{
			fprintf(out, "       ");
			fprintf(out, (char*)dsatz->email);
			fprintf(out, " ");
			}
	if(f[7])
		if(dsatz->handy[0] != SPACE)
			{
			fprintf(out, "Handy: ");
			fprintf(out, (char*)dsatz->handy);
			}

	if(!f[8])
		{
		fprintf(out, "\n");
		return;
		}

	if(f[6] || f[7])
		{
		fprintf(out,"\n");
		for(i=0;i<=NAMEMAX-6;i++)
			fprintf(out, " ");
      }
	if(f[8])
		fprintf(out, (char*)dsatz->bemerk);

	fprintf(out,"\n");
	}

void markierprn(int zeile, int farb)                 /* markiert eine Druck */
	{
	int off=zeile*160+XSTART*2;
	int seg=(peekb(0x40,0x49)==7)?0xb000:0xb800;
	int i;
	if(farb>=0)
		{
		for(i=1;i<31;i+=2)
			pokeb(seg,off+i,(farb) ? MARKCOLOR : 0x7);
		if(farb==1) return;
		for(;i<49; i+=2)
			pokeb(seg, off+i, 0x7);
		return;
		}
	off+=4;
	for(; peekb(seg, off)!=SPACE || peekb(seg, off+2)!=SPACE; off+=2)
		pokeb(seg,off+1,MARKCOLOR/16 + (MARKCOLOR%16)*16);
   }

void drucken(void)                            /* druckt Daten */
	{
	int zeile=-3;
	int ystd = YSTART + 5;
	int spalte=XSTART+2;
	int kat[9]={0,0,0,0,0,0,0,0,0};
	int *druck;
	int cont=1;
	int i;
	if(!anz)
		{
		ps(YSTART, XSTART, "Was willst Du drucken? -- Keine Daten vorhanden!");
		WAIT;
		return;
		}
	if((druck=(int *) malloc((anz+1)*sizeof(int)))==NULL) memoryerror();
	for(i=0;i<=anz;i++)
		druck[i]=0;
	ps(YSTART,XSTART,"Welche Kategorien drucken?");   /* Kategorien whlen */
	ps(YSTART+2, spalte,"Alle");
	ps(YSTART+3, spalte,"Alle auer Bemerkungen");
	ps(ystd,spalte,"Name");
	ps(ystd+1,spalte,"Vorname");
	ps(ystd+2,spalte,"Strae");
	ps(ystd+3,spalte,"PLZ Ort");
	ps(ystd+4,spalte,"Telefon-Nr.");
	ps(ystd+5,spalte,"Geburtstag");
	ps(ystd+6,spalte,"eMail-Adr.");
	ps(ystd+7,spalte,"Handy/Pager");
	ps(ystd+8,spalte,"Bemerkungen");
	markierprn(ystd + zeile, -1);
	mark(24,0,80);
	ps(24,0,"  Pfeile  <: (De-/)Markieren  ^Y: Clear  ^I: Invert F10: Weiter  ESC: Abbruch");
	CUP(ystd+zeile,spalte);
	while(cont)
		{
		switch(keyb())
			{
			case ESC:
				free(druck);
				return;
			case RETURN:
				if(zeile<0)
					{
					for(i=1;i<BEMERK;i++)
						kat[i-1]=1;
					kat[i-1]=(zeile==-3);
					cont=0;
					break;
					}
				kat[zeile]=!kat[zeile];
				markierprn(ystd+zeile, kat[zeile]);
				markierprn(ystd+zeile, -1);
				break;
			case STRG_Y:
				for(i=0; i<BEMERK; i++)
					{
					kat[i]=0;
					markierprn(ystd+i,kat[i]);
					}
				markierprn(ystd+zeile, -1);
				break;
			case STRG_I:
				for(i=0; i<BEMERK; i++)
					{
					kat[i]=!kat[i];
					markierprn(ystd+i,kat[i]);
					}
				markierprn(ystd+zeile, -1);
				break;

			case ALT_X:
				quit(0);

			case F10:
				cont=0;
				break;

			case DOWN:
				markierprn(ystd+zeile, (zeile>=0) ? kat[zeile] : 0);
				zeile+=1+(zeile==-2);
				if(zeile>BEMERK-1) zeile=-3;
				markierprn(ystd+zeile, -1);
				CUP(ystd+zeile, spalte);
				break;

			case UP:
				markierprn(ystd+zeile, (zeile>=0) ? kat[zeile] : 0);
				zeile-= 1+(zeile==0);
				if(zeile < -3) zeile=BEMERK-1;
				markierprn(ystd+zeile, -1);
				CUP(ystd+zeile, spalte);
				break;
			}
      }
	ED;
	zeile=1;
	ystd=YSTART+2;
	ps(YSTART, XSTART,"Welche Daten drucken?");   /* Daten whlen */
	ps(YSTART+3, spalte,"Alle");
	ps(YSTART+4, spalte,"Auswhlen");
	markierprn(ystd+zeile, 1);
	CUP(ystd+zeile,spalte);
	cont=1;
	while(cont)
		{
		switch(keyb())
			{
			case ESC:
				free(druck);
				return;
			case RETURN:
				if(zeile==1)
					{
					for(i=0;i<anz;i++)
						druck[i]=1;
					}
				else if(anzeigprn(druck))
					{
					free(druck);
					return;
					}
				cont = 0;
				break;

			case DOWN:
			case UP:
				markierprn(ystd+zeile,0);
				zeile = 1+(zeile==1);
				markierprn(ystd+zeile,1);
				CUP(ystd+zeile,spalte);
				break;
			case ALT_X:
				quit(0);
			}
      }
	ED;
	ps(YSTART,XSTART,"Wenn Drucker betriebsbereit, beliebige Taste drcken.");
	ps(YSTART+1,XSTART,"ESC zum Abbruch");
	if(keyb()==ESC)
		{
		free(druck);
		return;
		}
	ED;
	ps(YSTART+4,XSTART,"Drucke... Datensatz Nr.:");
	for(i=0;i<anz;i++)
		if(druck[i])
			{
			CUP(YSTART+4, XSTART+24);
			put_intf(i, 3);
			drucksatz(&adr[i], kat);
			}

	free(druck);
	}

void datei_wechseln(void)
	{
	int ystart = YSTART + 2;
	int einfg=1, down=1;
	int i;
	char copy[9];
	char copy_datei[13];
	strcpy(copy_datei, datei);
	strcpy(copy, "        ");
	CUP(ystart, XSTART);
	printf("Du befindest Dich in der Datei \"%s\"", datei);
	CUP(ystart+2, XSTART);
	printf("Gib jetzt den Namen der Datei ein,");
	CUP(ystart+3, XSTART);
	printf("in die Du wechseln willst:  (ohne \".dat\")");

	CUP(ystart+5, XSTART+1);
	mark(ystart+5, XSTART, XSTART+10);
	bearbeiten(copy, ystart+5, XSTART+1, &einfg, &down);
	if(down != 2) return;


	if(change) savefile();
	if(fclose(fp) == EOF)
		{
		ED;
		psyx("Probleme beim Dateihandling. Progamm wurde abgebrochen.\n\r");
		exit(1);
		}

	for(i = strlen(copy)-1; copy[i] == SPACE; copy[i]=0, i--);
	if(strlen(copy) == 0) strcpy(copy, "adressen");
	strcpy(datei, copy);
	strcat(datei, ".dat");
	if(openfile() == TROUBLE)
		{
		strcpy(datei, copy_datei);
		if(openfile() == TROUBLE) {ED; exit(1);}
		}
	}

void execute(int n)              /* Fhrt einen Menpunkt aus */
	{
	ED;
	switch(n)
		{
		case ANZEIG:
			anzeig();
			break;
		case SUCHEN:
			suchen();
			break;
		case HINZFG:
			hinzfg();
			break;
		case ALPHABET:
			alphabet();
			break;
		case DRUCKEN:
			drucken();
			break;
		case DATEI:
			datei_wechseln();
			break;
		}
	mainscreen(n);
	if(mouevent & BUTTP) while(mouevent & BUTTP);
	}
